<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="header">
        <h:outputStylesheet library="stylesheet" name="style-OrderManager.css"/>
    </ui:define>
    <ui:define name="body">
        <h:form id="globalForm">
            <h1>#{messages['gazelle.ordermanager.ModalityWorklistInformationModelFind']}</h1>
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.SendModalityWorklistQueriesToYourOrderFiller']}</f:facet>
                <s:div id="messageConfigurationDiv" styleClass="row">
                    <div class="col-md-4">
                        <gri:panel bodyClass="inpanelBody">
                            <f:facet name="header">
                                #{messages['gazelle.HL7Common.Simulator']}
                            </f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.HL7Common.Name']}</ui:define>
                                    <h:outputText value="#{messages['gazelle.ordermanager.AquisitionModality']}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.ordermanager.AETitle']}</ui:define>
                                    <h:outputText value="#{messages['gazelle.ordermanager.GAZELLEOM']}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                    <div class="col-md-4">
                        <h:graphicImage library="img" name="diag/RAD-5-MOD.png"/>
                    </div>
                    <div class="col-md-4">
                        <gri:panel rendered="#{worklistProviderTester.selectedSUT != null}">
                            <f:facet name="header">#{messages['gazelle.HL7Common.SystemUnderTest']}</f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.HL7Common.Name']}</ui:define>
                                    <h:outputText value="#{worklistProviderTester.selectedSUT.name}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.ordermanager.Host']}</ui:define>
                                    <h:outputText value="#{worklistProviderTester.selectedSUT.host}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.HL7Common.Port']}</ui:define>
                                    <h:outputText value="#{worklistProviderTester.selectedSUT.port}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.ordermanager.AETitle']}</ui:define>
                                    <h:outputText value="#{worklistProviderTester.selectedSUT.aeTitle}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                </s:div>
                <div class="form-horizontal">
                    <s:decorate id="configSelectionDecorate"
                                template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['gazelle.HL7Common.SutConfiguration']}</ui:define>
                        <ui:param name="id" value="configSelectionBox"/>
                        <h:selectOneMenu id="configSelectionBox" value="#{worklistProviderTester.selectedSUT}"
                                         styleClass="form-control gzl-select-text">
                            <s:selectItems value="#{worklistProviderTester.getAvailableSUT()}" var="conf"
                                           noSelectionLabel="#{messages['gazelle.simulator.PleaseSelect']}"
                                           label="#{conf.name}"/>
                            <a4j:ajax event="change"
                                      execute="@this" render="messageConfigurationDiv"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </div>
                <s:div id="globalDiv">
                    <gri:panel id="queryConf" rendered="#{worklistProviderTester.connectionId == null}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.QueryConfiguration']}</f:facet>
                        <h:outputText styleClass="help-block"
                                      value="#{messages['gazelle.ordermanager.BelowIsATreeViewOfTheDICOMMessageModalityWorklis']} "/>
                        <div class="row">
                            <div class="col-md-6">
                                <rich:panel styleClass="gzl-alert gzl-alert-blue">
                                    <ui:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="choice"/>
                                        <ui:define name="label">#{messages['gazelle.ordermanager.AttributesToHighlight']}</ui:define>
                                        <h:selectOneMenu value="#{worklistProviderTester.keysToHighlight}"
                                                         styleClass="form-control" id="choice">
                                            <f:selectItems value="#{worklistProviderTester.getHighlightModes()}"/>
                                            <a4j:ajax event="change" render="treeOfParams"/>
                                        </h:selectOneMenu>
                                    </ui:decorate>
                                </rich:panel>
                                <rich:tree id="treeOfParams" value="#{worklistProviderTester.getQueryAsTree()}"
                                           var="node" style="vertical-align:top" toggleType="client">
                                    <rich:treeNode rendered="#{node.data.class.simpleName.equals('SequenceAttribute')}"
                                                   id="sequenceBranch">
                                        <a4j:commandLink
                                                actionListener="#{worklistProviderTester.setSelectedSequence(node.data)}"
                                                render="globalDiv" title="#{messages['gazelle.ordermanager.AddAnItem']}">
                                            <s:span styleClass="gzl-icon-plus"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.RemoveSequence']}"
                                                         actionListener="#{worklistProviderTester.removeAttribute(node.data)}"
                                                         render="treeOfParams">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                        <h:outputText
                                                value="#{worklistProviderTester.getNameFromTag(node.data.getTag())}"
                                                style="font-weight:bold;"/>
                                        <h:outputText value=" #{node.data.getTag().toString()}"/>
                                        <h:outputText value=" &lt;#{node.data.getVRAsString()}&gt;"/>
                                    </rich:treeNode>
                                    <rich:treeNode
                                            rendered="#{not node.data.class.simpleName.equals('SequenceAttribute')}"
                                            id="attributeLeaf">
                                        <a4j:commandLink
                                                actionListener="#{worklistProviderTester.emptyAttribute(node.data)}"
                                                render="treeOfParams" title="#{messages['gazelle.ordermanager.EmptyAttribute']}">
                                            <span class="fa fa-eraser gzl-text-orange"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink
                                                actionListener="#{worklistProviderTester.removeAttribute(node.data)}"
                                                render="treeOfParams" title="#{messages['gazelle.ordermanager.RemoveAttribute']}">
                                            <s:span styleClass="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                        <h:outputText
                                                value="#{worklistProviderTester.getNameFromTag(node.data.getTag())}"
                                                style="font-weight:bold;"
                                                styleClass="#{worklistProviderTester.getStyleClassForNode(node.data.getTag())}"/>
                                        <h:outputText value=" #{node.data.getTag().toString()}"/>
                                        <h:outputText value=" &lt;#{node.data.getVRAsString()}&gt;"/>
                                        <h:outputText value=" &lt;"/>
                                        <a4j:region>
                                            <rich:inplaceInput defaultLabel="click to add a value"
                                                               value="#{worklistProviderTester.attributeValue}"
                                                               showControls="true"
                                                               rendered="#{node.data.getDelimitedStringValuesOrNull() == null}">
                                                <a4j:ajax event="change" render="treeOfParams"
                                                          listener="#{worklistProviderTester.setAttributeValue(node.data)}"/>
                                            </rich:inplaceInput>
                                        </a4j:region>
                                        <h:outputText rendered="#{node.data.getDelimitedStringValuesOrNull() != null}"
                                                      value="#{node.data.getDelimitedStringValuesOrNull()}"/>
                                        <h:outputText value=" &gt;"/>
                                    </rich:treeNode>
                                </rich:tree>
                            </div>
                            <div class="col-md-6">
                                <gri:panel id="editPanel">
                                    <f:facet name="header">
                                        <s:div>
                                            <h:outputText value="#{messages['gazelle.ordermanager.AddAnAttributeToTheQuery']}"/>
                                            <h:outputText
                                                    value=" #{messages['gazelle.ordermanager.ForSequence']} #{worklistProviderTester.selectedSequence.getTag().toString()}"
                                                    rendered="#{worklistProviderTester.selectedSequence != null}"/>
                                        </s:div>
                                    </f:facet>
                                    <s:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="tagid"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.ordermanager.AddAttributeByTageg0xGGGG0xEEEE']})"/>
                                        </ui:define>
                                        <h:inputText value="#{worklistProviderTester.attributeTag}"
                                                     id="tagid" styleClass="form-control"/>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Add']}"
                                                         actionListener="#{worklistProviderTester.addAnAttribute()}"
                                                         rendered="#{worklistProviderTester.selectedSequence == null}"
                                                         render="globalDiv">
                                            <s:span styleClass="gzl-icon-plus"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Add']}" render="globalDiv"
                                                         actionListener="#{worklistProviderTester.addAnAttributeToSequence()}"
                                                         rendered="#{worklistProviderTester.selectedSequence != null}">
                                            <s:span styleClass="gzl-icon-plus"/>
                                        </a4j:commandLink>
                                    </s:decorate>
                                    <h:outputText value="#{messages['gazelle.ordermanager.Or']}" style="font-weight:bold;text-align:center;"/>
                                    <s:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="tagname"/>
                                        <ui:define name="label">
                                            <h:outputText value="#{messages['gazelle.ordermanager.SelectItsNameFromList']}"/>
                                        </ui:define>
                                        <h:selectOneMenu styleClass="form-control gzl-select-text"
                                                         value="#{worklistProviderTester.attributeTagName}"
                                                         id="tagname">
                                            <s:selectItems value="#{worklistProviderTester.listOfTagsByName}"
                                                           var="st"
                                                           label="#{st}" noSelectionLabel="#{messages['gazelle.ordermanager.PleaseSelect']}"/>
                                        </h:selectOneMenu>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Add']}"
                                                         actionListener="#{worklistProviderTester.addAnAttributeByTagName()}"
                                                         rendered="#{worklistProviderTester.selectedSequence == null}"
                                                         render="globalDiv">
                                            <s:span styleClass="gzl-icon-plus"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Add']}"
                                                         actionListener="#{worklistProviderTester.addAnAttributeByTagNameToSequence()}"
                                                         rendered="#{worklistProviderTester.selectedSequence != null}"
                                                         render="globalDiv">
                                            <s:span styleClass="gzl-icon-plus"/>
                                        </a4j:commandLink>
                                    </s:decorate>
                                    <f:facet name="footer">
                                        <a4j:commandButton value="#{messages['gazelle.ordermanager.CancelEdition']}"
                                            styleClass="gzl-btn" actionListener="#{worklistProviderTester.setSelectedSequence(null)}"
                                            render="globalDiv" rendered="#{worklistProviderTester.selectedSequence != null}"/>
                                    </f:facet>
                                </gri:panel>
                            </div>
                        </div>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['gazelle.ordermanager.SendMessage']}"
                                               actionListener="#{worklistProviderTester.executeQuery()}"
                                               render="globalDiv" styleClass="gzl-btn-blue"/>
                        </f:facet>
                    </gri:panel>
                    <gri:panel pid="messagePanel" rendered="#{worklistProviderTester.connectionId != null}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.TestReport']}</f:facet>
                        #{dataTableStateHolder.setAscendingOn('timestamp')}
                        <rich:dataTable value="#{worklistProviderTester.dicomMessages}" var="msg"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="dcmlist"
                            render="ds">
                            <ui:include src="/common/dicomMessageColumns.xhtml">
                                <ui:param name="dcmMessage" value="#{msg}"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['users.Action']}</ui:define>
                                <h:outputLink
                                        value="#{applicationConfiguration.getValueOfVariable('application_url')}#{dicomMessageBrowser.getPermanentLink(msg.id)}"
                                        title="#{messages['gazelle.ordermanager.MoreDetails']}">
                                    <s:span styleClass="gzl-icon-search "/>
                                </h:outputLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="dcmlist"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}" styleClass="gzl-btn-blue"
                                               actionListener="#{worklistProviderTester.performAnotherTest()}"
                                               render="globalDiv"/>
                        </f:facet>
                    </gri:panel>
                </s:div>
            </gri:panel>
        </h:form>
    </ui:define>
</ui:composition>
